/*
 * pstack - ץåȥե¸ʬ
 *
 * (C)Copyright 2009-2011, Yashiro Takeshi <yashiromann@nifty.com>
 */

#include <basic.h>
#include <stdio.h>
#include <tk/tkernel.h>
#include <tk/dbgspt.h>
#include <device/util.h>
#include <util/debug.h>


/* From the book "Binary Hacks", Hack #63 */
typedef struct layout {
    struct layout *ebp;
    void* ret;
    void* ret_spc;
} layout;


#define IN_SYSSTACK(p, cregs) ((((UW)(p)) <= ((UW)((cregs).esp0))) && (((UW)(p)) >= ((UW)((cregs).ssp))))
#define IN_USERSTACK(p, cregs) ((((UW)(p)) >= ((UW)((cregs).usp))) && (((UW)(p)) < 0x80000000U))


ER pstk_backtrace(ID tid, VP* stack, int n)
{
    ER er;
    T_REGS pk_regs;
    T_EIT pk_eit;
    T_CREGS pk_cregs;
    layout* frame;
    int i;

    er = tk_get_reg(tid, &pk_regs, &pk_eit, &pk_cregs);
    if (er < 0) {
        return er;
    }

    if (n > 0) {
        stack[0] = (VP)(pk_eit.eip);
    }

    frame = (layout*)(pk_regs.ebp);
    if (frame == NULL) {
        return (n > 0) ? 1 : 0;
    }

    for (i = 1; i < n; ) {
        if (frame == NULL
            || ChkSpaceR(frame, sizeof(layout)) != E_OK
            || frame->ebp == NULL) {
            break;
        }
        if (IN_SYSSTACK(frame, pk_cregs) 
            && IN_USERSTACK(frame->ebp, pk_cregs)) {
            /* T-MonitorǥפǤϡebpƥॹå桼å
               ڤؤ륿ߥ󥰤ǡretʬ;פ(0x0000003bȤ)
               äƤߤʤΤǡȤꤢ̤˰ */
            /* FIXME: ǤԽʬǡͥǥƥॳƤȤ
               ξ true ˤʤ褦ˤʤФʤʤäݤ */
            if (frame->ret_spc == NULL) {
                break;
            }
            stack[i++] = (VP)(frame->ret_spc);
            if (i >= n) {
                break;
            }

            /* ƥॳξϡuspΥɥ쥹iflibꥢɥ쥹
               ֤뤽ʤΤǡɲä롣
               (ʤebpΥե졼फäƤΤ) */
            /* FIXME: ͥ⡼ɤiflibȤäνϤɤ뤫 */
            stack[i++] = *((VP*)(pk_cregs.usp));
        }
        else {
            if (frame->ret == NULL) {
                break;
            }
            stack[i++] = (VP)(frame->ret);
        }

        frame = frame->ebp;
    }

    return i;
}
