/*
 * pstkdrv - ץåȥեඦʬ
 *
 * (C)Copyright 2009-2011, Yashiro Takeshi <yashiromann@nifty.com>
 */

#include <basic.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tk/tkernel.h>
#include <tk/util.h>
#include <tk/dbgspt.h>
#include <device/sdrvif.h>
#include <device/util.h>
#include <util/debug.h>
#include <util/tmonitor.h>

extern ER pstk_backtrace(ID tid, VP* stack, int n);

static ID  pstk_accept_tid = -1;
static ID  pstk_accept_por = -1;
static ID  pstk_mbf;
static SDI pstk_sdi;

static ID  pstk_killer_tid = -1;

/* ǼPCο */
#define MAX_PC 128

static VP pstk_stkbuf[MAX_PC];

#define PSTKDRV_DEVNM "pstkdrv"

typedef struct {
    ID  tid;
    W   n;
} PstkRequest;

typedef struct {
    VP* buf;
    W   n;
} PstkReply;


static void pstk_reply(RNO rno, PstkRequest* req)
{
    T_TSKSPC tskspc;
    PstkReply rpl;
    ER er;
    int suspended = 0;
    memset(&rpl, 0, sizeof(PstkReply));
    
    /* оݤΥԤ֤ˤ
       (åȥ졼˥λƸ֤ͭǤꡢ
       åΤƤѹ줿ꤹΤɤ) */
    er = tk_sus_tsk(req->tid);
    suspended = (er >= 0);

    /* ֤ͭоݥΤΤ˹碌 */
    er = tk_get_tsp(req->tid, &tskspc);
    if (er < 0) {
        goto err_ret;
    }

    er = tk_set_tsp(TSK_SELF, &tskspc);
    if (er < 0) {
        goto err_ret;
    }

    /* åPCŬ˼ */
    if (req->n > MAX_PC) {
        req->n = MAX_PC;
    }
    rpl.buf = pstk_stkbuf;

    er = pstk_backtrace(req->tid, rpl.buf, req->n);
    if (er < 0) {
        goto err_ret;
    }
    rpl.n = er;

    if (suspended) {
        tk_rsm_tsk(req->tid);
    }

    tk_rpl_rdv(rno, (VP)&rpl, sizeof(PstkReply));
    return;

err_ret:
    if (suspended) {
        tk_rsm_tsk(req->tid);
    }

    memset(&rpl, 0, sizeof(PstkReply));
    tk_rpl_rdv(rno, (VP)&rpl, sizeof(PstkReply));
}


static void pstk_accept_task(INT stacd, VP exinf)
{
    ER er;
    T_CPOR pk_cpor;
    PstkRequest req;
    RNO rno;

    SetOBJNAME(pk_cpor.exinf, "pstk");
    pk_cpor.poratr = TA_TFIFO;
    pk_cpor.maxcmsz = sizeof(PstkRequest);
    pk_cpor.maxrmsz = sizeof(PstkReply);
    er = tk_cre_por(&pk_cpor);
    if (er < 0) {
        goto err_ret0;
    }
    pstk_accept_por = er;

    while (pstk_killer_tid < 0) {
        er = tk_acp_por(pstk_accept_por, 1, &rno, (VP)&req, TMO_FEVR);
        if (er == sizeof(PstkRequest)) {
            pstk_reply(rno, &req);
        }
        else if (er == E_RLWAI) {
            break;
        }
        else {
            printf("pstkdrv: bad request (%d)\n", er);
            goto err_ret1;
        }
    }

err_ret1:
    pstk_accept_tid = -1;
    if (pstk_accept_por >= 0) {
        tk_del_por(pstk_accept_por);
        pstk_accept_por = -1;
    }

err_ret0:
    pstk_accept_tid = -1;
    if (pstk_killer_tid >= 0) {
        tk_wup_tsk(pstk_killer_tid);
        pstk_killer_tid = -1;
    }
    tk_exd_tsk();
}


static INT pstk_readfn(ID devid, INT start, INT size, VP buf, SDI sdi)
{
    ER er;
    union {
        PstkRequest req;
        PstkReply rpl;
    } pkt;

    if (start < 0) {
        return E_PAR;
    }
    if (size != 0 && ChkSpaceRW(buf, size) != E_OK) {
        return E_MACV;
    }

    pkt.req.tid = start;
    pkt.req.n = (size == 0) ? MAX_PC : (size / sizeof(VP));

    er = tk_cal_por(pstk_accept_por, 1, (VP)&pkt, 
                    sizeof(PstkRequest), TMO_FEVR);
    if (er < 0) {
        return er;
    }

    if (buf != NULL && size != 0) {
        memcpy(buf, pkt.rpl.buf, sizeof(VP) * pkt.rpl.n);
    }
    return pkt.rpl.n * sizeof(VP);
}


static ER pstk_init()
{
    ER er;
    T_CTSK pk_ctsk;

    SetOBJNAME(pk_ctsk.exinf, "pstk");
    pk_ctsk.tskatr = TA_HLNG|TA_RNG0;
    pk_ctsk.task = pstk_accept_task;
    pk_ctsk.itskpri = 80; /* ץեоݤͥ٤Ǥʤ */
    pk_ctsk.stksz = 4096;

    er = tk_cre_tsk(&pk_ctsk);
    if (er < 0) {
        goto err_ret0;
    }
    pstk_accept_tid = er;

    er = tk_sta_tsk(pstk_accept_tid, 0);
    if (er < 0) {
        goto err_ret1;
    }

    return 0;

err_ret1:
    tk_del_tsk(pstk_accept_tid);
    pstk_accept_tid = -1;

err_ret0:
    return er;
}


static ER pstk_finish()
{
    ER er;

    /* ׵եʬǽλΤԤ */
    pstk_killer_tid = tk_get_tid();
    tk_rel_wai(pstk_accept_tid);
    er = tk_slp_tsk(1000);

    /* ʬǤȽλƤʤϡʤΤ̵λ */
    if (pstk_accept_tid >= 0) {
        tk_ter_tsk(pstk_accept_tid);
        tk_del_tsk(pstk_accept_tid);
        pstk_accept_tid = -1;
    }

    if (pstk_accept_por >= 0) {
        tk_del_por(pstk_accept_por);
        pstk_accept_tid = -1;
    }
}


ER main(INT ac, UB *av[])
{
    ER er;
    T_IDEV idev;
    static SDefDev ddev = {
        NULL,           /* exinf */
        PSTKDRV_DEVNM,  /* devnm */
        0,              /* drvatr */
        0,              /* devatr */
        0,              /* nsub */
        1,              /* blksz */
        NULL,           /* open */
        NULL,           /* close */
        pstk_readfn,    /* read */
        NULL,           /* write */
        NULL,
    };

    /* Terminate request */
    if (ac < 0) {
        pstk_finish();
        return E_OK;
    }

    /* Driver initialization */
    er = pstk_init();
    if (er < 0) {
        goto err_ret;
    }

    /* Device registration */
    er = SDefDevice(&ddev, &idev, &pstk_sdi);
    if (er < 0) {
        goto err_ret;
    }
    pstk_mbf = idev.evtmbfid;

    return 0;

err_ret:
    return er;
}

